/* AP 08-oct-12 compare.c					*/
/*		Vergleiche zwei Dateien zeilenweise 		*/
/*		Gib Zeilen aus, in denen sie sich unterscheiden	*/


# include <stdio.h>
# include <string.h>
# include <stdlib.h>

# define LINELEN 1000

void compare_line( char *line1, char *line2, int linenum ) {
	if(strcmp (line1, line2) != 0)
    		printf( "%d<%s%d>%s", linenum, line1, linenum, line2);
}

int main(int argc, char *argv[] ) {
	char * prog = argv[0];
  	FILE *fp1, *fp2;
  	char line1[LINELEN], line2[LINELEN];
  	int i;

  	if ( argc < 3 ) {
		fprintf(stderr, "usage: %s <file1> <file2>\n", prog);
      		return 1;
	}
  	fp1 = fopen( argv[1], "r" );
  	if ( ! fp1 ) {
      		fprintf(stderr, "Error opening file %s\n", argv[1]);
		return 2;
	}
  	fp2 = fopen( argv[2], "r" );
  	if ( ! fp2 ) {
      		fprintf(stderr, "Error opening file %s\n", argv[2]);
		return 3;
	}
  	i = 0;
  	while ( (fgets(line1, sizeof(line1), fp1) != NULL) 
	  	&& (fgets(line2, sizeof(line2), fp2) != NULL)) {
		compare_line( line1, line2, i );
    		i++;
  	}
	fclose( fp1 );
	fclose( fp2 );
  	return 0;
}
